DROP TABLE IF EXISTS USERS CASCADE;
CREATE TABLE USERS
(
    ID          SERIAL,
    USERNAME    VARCHAR(100) NOT NULL,
    EMAIL       VARCHAR(100) NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

DROP TABLE IF EXISTS TEST_SUITES CASCADE;
CREATE TABLE IF NOT EXISTS TEST_SUITES
(
    ID          SERIAL,
    NAME        VARCHAR(200) NOT NULL,
    DESCRIPTION TEXT         NULL,
    FILE_NAME   VARCHAR(255) NOT NULL DEFAULT '',
    USER_ID     INT          NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID)
);

DROP TABLE IF EXISTS PROJECTS CASCADE;
CREATE TABLE IF NOT EXISTS PROJECTS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    DESCRIPTION TEXT         NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

DROP TABLE IF EXISTS TEST_CASES CASCADE;
CREATE TABLE IF NOT EXISTS TEST_CASES
(
    ID                 SERIAL,
    TEST_CLASS         VARCHAR(255) NOT NULL,
    TEST_METHOD        VARCHAR(255) NOT NULL,
    INFO               TEXT         NULL,
    TEST_SUITE_ID      INT          NOT NULL,
    PRIMARY_OWNER_ID   INT          NOT NULL,
    SECONDARY_OWNER_ID INT          NULL,
    PROJECT_ID         INT          NULL,
    STATUS             VARCHAR(20)  NOT NULL DEFAULT 'UNKNOWN',
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_SUITE_ID) REFERENCES TEST_SUITES (ID),
    FOREIGN KEY (PRIMARY_OWNER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (SECONDARY_OWNER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (PROJECT_ID) REFERENCES PROJECTS (ID)
);

DROP TABLE IF EXISTS WORK_ITEMS CASCADE;
CREATE TABLE IF NOT EXISTS WORK_ITEMS
(
    ID           SERIAL,
    JIRA_ID      VARCHAR(45) NOT NULL,
    TYPE         VARCHAR(45) NOT NULL DEFAULT 'TASK',
    HASH_CODE    INT         NULL,
    DESCRIPTION  TEXT        NULL,
    USER_ID      INT         NULL,
    TEST_CASE_ID INT         NULL,
    KNOWN_ISSUE  BOOLEAN     NOT NULL DEFAULT FALSE,
    BLOCKER      BOOLEAN     NOT NULL DEFAULT FALSE,
    MODIFIED_AT  TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASES (ID)
);

DROP TABLE IF EXISTS INTEGRATION_GROUPS CASCADE;
CREATE TABLE IF NOT EXISTS INTEGRATION_GROUPS
(
    ID               SERIAL,
    NAME             VARCHAR(50)  NOT NULL,
    DISPLAY_NAME     VARCHAR(50)  NOT NULL,
    ICON_URL         VARCHAR(255) NOT NULL,
    MULTIPLE_ALLOWED BOOLEAN      NOT NULL DEFAULT FALSE,
    MODIFIED_AT      TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT       TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

DROP TABLE IF EXISTS INTEGRATION_TYPES CASCADE;
CREATE TABLE IF NOT EXISTS INTEGRATION_TYPES
(
    ID                   SERIAL,
    NAME                 VARCHAR(50)  NOT NULL,
    DISPLAY_NAME         VARCHAR(50)  NOT NULL,
    ICON_URL             VARCHAR(255) NOT NULL,
    INTEGRATION_GROUP_ID INT          NOT NULL,
    MODIFIED_AT          TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT           TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_GROUP_ID) REFERENCES INTEGRATION_GROUPS (ID)
);

DROP TABLE IF EXISTS INTEGRATIONS CASCADE;
CREATE TABLE IF NOT EXISTS INTEGRATIONS
(
    ID                  SERIAL,
    NAME                VARCHAR(50) NOT NULL,
    BACK_REFERENCE_ID   VARCHAR(50) NULL,
    IS_DEFAULT          BOOLEAN     NOT NULL DEFAULT FALSE,
    ENABLED             BOOLEAN     NOT NULL DEFAULT FALSE,
    INTEGRATION_TYPE_ID INT         NOT NULL,
    MODIFIED_AT         TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT          TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_TYPE_ID) REFERENCES INTEGRATION_TYPES (ID)
);

DROP TABLE IF EXISTS INTEGRATION_PARAMS CASCADE;
CREATE TABLE IF NOT EXISTS INTEGRATION_PARAMS
(
    ID                  SERIAL,
    NAME                VARCHAR(50) NOT NULL,
    METADATA            TEXT        NULL,
    DEFAULT_VALUE       TEXT        NULL,
    MANDATORY           BOOLEAN     NOT NULL DEFAULT FALSE,
    NEED_ENCRYPTION     BOOLEAN     NOT NULL DEFAULT FALSE,
    INTEGRATION_TYPE_ID INT         NOT NULL,
    MODIFIED_AT         TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT          TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_TYPE_ID) REFERENCES INTEGRATION_TYPES (ID)
);

DROP TABLE IF EXISTS INTEGRATION_SETTINGS CASCADE;
CREATE TABLE IF NOT EXISTS INTEGRATION_SETTINGS
(
    ID                   SERIAL,
    VALUE                TEXT      NULL,
    BINARY_DATA          BYTEA     NULL,
    ENCRYPTED            BOOLEAN   NOT NULL DEFAULT FALSE,
    INTEGRATION_ID       INT       NOT NULL,
    INTEGRATION_PARAM_ID INT       NOT NULL,
    MODIFIED_AT          TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT           TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (INTEGRATION_ID) REFERENCES INTEGRATIONS (ID),
    FOREIGN KEY (INTEGRATION_PARAM_ID) REFERENCES INTEGRATION_PARAMS (ID)
);

DROP TABLE IF EXISTS JOBS CASCADE;
CREATE TABLE IF NOT EXISTS JOBS
(
    ID                   SERIAL,
    USER_ID              INT          NULL,
    NAME                 VARCHAR(100) NOT NULL,
    JOB_URL              VARCHAR(255) NOT NULL,
    JENKINS_HOST         VARCHAR(255) NULL,
    AUTOMATION_SERVER_ID INT          NULL,
    MODIFIED_AT          TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT           TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (AUTOMATION_SERVER_ID) REFERENCES INTEGRATIONS (ID)
);

DROP TABLE IF EXISTS TEST_CONFIGS CASCADE;
CREATE TABLE IF NOT EXISTS TEST_CONFIGS
(
    ID               SERIAL,
    URL              VARCHAR(512) NULL,
    ENV              VARCHAR(50)  NULL,
    PLATFORM         VARCHAR(30)  NULL,
    PLATFORM_VERSION VARCHAR(30)  NULL,
    BROWSER          VARCHAR(30)  NULL,
    BROWSER_VERSION  VARCHAR(30)  NULL,
    APP_VERSION      VARCHAR(255) NULL,
    LOCALE           VARCHAR(30)  NULL,
    LANGUAGE         VARCHAR(30)  NULL,
    DEVICE           VARCHAR(50)  NULL,
    MODIFIED_AT      TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT       TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

DROP TABLE IF EXISTS TEST_RUNS CASCADE;
CREATE TABLE IF NOT EXISTS TEST_RUNS
(
    ID                        SERIAL,
    CI_RUN_ID                 VARCHAR(50)  NULL,
    USER_ID                   INT,
    TEST_SUITE_ID             INT          NOT NULL,
    STATUS                    VARCHAR(20)  NOT NULL,
    SCM_URL                   VARCHAR(255) NULL,
    SCM_BRANCH                VARCHAR(100) NULL,
    SCM_COMMIT                VARCHAR(100) NULL,
    CONFIG_XML                TEXT         NULL,
    WORK_ITEM_ID              INT          NULL,
    JOB_ID                    INT          NULL,
    BUILD_NUMBER              INT          NOT NULL,
    STARTED_BY                VARCHAR(45)  NULL,
    UPSTREAM_JOB_ID           INT          NULL,
    UPSTREAM_JOB_BUILD_NUMBER INT          NULL,
    PROJECT_ID                INT          NULL,
    CONFIG_ID                 INT          NULL,
    KNOWN_ISSUE               BOOLEAN      NOT NULL DEFAULT FALSE,
    BLOCKER                   BOOLEAN      NOT NULL DEFAULT FALSE,
    ENV                       VARCHAR(50)  NULL,
    APP_VERSION               VARCHAR(255) NULL,
    STARTED_AT                TIMESTAMP    NULL,
    ENDED_AT                  TIMESTAMP    NULL,
    ELAPSED                   INT          NULL,
    ETA                       INT          NULL,
    COMMENTS                  TEXT         NULL,
    CHANNELS                  VARCHAR(255) NULL,
    REVIEWED                  BOOLEAN      NOT NULL DEFAULT FALSE,
    FRAMEWORK                 VARCHAR(50)  NULL,
    MODIFIED_AT               TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT                TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID),
    FOREIGN KEY (TEST_SUITE_ID) REFERENCES TEST_SUITES (ID),
    FOREIGN KEY (WORK_ITEM_ID) REFERENCES WORK_ITEMS (ID),
    FOREIGN KEY (JOB_ID) REFERENCES JOBS (ID),
    FOREIGN KEY (UPSTREAM_JOB_ID) REFERENCES JOBS (ID),
    FOREIGN KEY (PROJECT_ID) REFERENCES PROJECTS (ID),
    FOREIGN KEY (CONFIG_ID) REFERENCES TEST_CONFIGS (ID)
);

DROP TABLE IF EXISTS TEST_RUN_ARTIFACTS CASCADE;
CREATE TABLE IF NOT EXISTS TEST_RUN_ARTIFACTS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    LINK        TEXT         NOT NULL,
    EXPIRES_AT  TIMESTAMP    NULL,
    TEST_RUN_ID INT          NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_RUN_ID) REFERENCES TEST_RUNS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS TESTS CASCADE;
CREATE TABLE IF NOT EXISTS TESTS
(
    ID                 SERIAL,
    CI_TEST_ID         VARCHAR(50)  NULL,
    NAME               VARCHAR(255) NOT NULL,
    STATUS             VARCHAR(20)  NOT NULL,
    TEST_ARGS          TEXT         NULL,
    TEST_RUN_ID        INT          NOT NULL,
    TEST_CASE_ID       INT          NOT NULL,
    TEST_GROUP         VARCHAR(255),
    MESSAGE            TEXT         NULL,
    MESSAGE_HASH_CODE  INT          NULL,
    START_TIME         TIMESTAMP    NULL,
    FINISH_TIME        TIMESTAMP    NULL,
    RETRY              INT          NOT NULL DEFAULT 0,
    TEST_CONFIG_ID     INT          NULL,
    KNOWN_ISSUE        BOOLEAN      NOT NULL DEFAULT FALSE,
    BLOCKER            BOOLEAN      NOT NULL DEFAULT FALSE,
    NEED_RERUN         BOOLEAN      NOT NULL DEFAULT TRUE,
    DEPENDS_ON_METHODS VARCHAR(255) NULL,
    UUID               TEXT         NULL,
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_CONFIG_ID) REFERENCES TEST_CONFIGS (ID),
    FOREIGN KEY (TEST_RUN_ID) REFERENCES TEST_RUNS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (TEST_CASE_ID) REFERENCES TEST_CASES (ID)
);

DROP TABLE IF EXISTS TAGS CASCADE;
CREATE TABLE IF NOT EXISTS TAGS
(
    ID          SERIAL,
    NAME        VARCHAR(50)  NOT NULL,
    VALUE       VARCHAR(255) NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);


DROP TABLE IF EXISTS TEST_TAGS CASCADE;
CREATE TABLE IF NOT EXISTS TEST_TAGS
(
    ID          SERIAL,
    TEST_ID     INT       NOT NULL,
    TAG_ID      INT       NOT NULL,
    MODIFIED_AT TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (TAG_ID) REFERENCES TAGS (ID)
);

DROP TABLE IF EXISTS TEST_ARTIFACTS CASCADE;
CREATE TABLE IF NOT EXISTS TEST_ARTIFACTS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    LINK        TEXT         NOT NULL,
    EXPIRES_AT  TIMESTAMP    NULL,
    TEST_ID     INT          NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS TEST_WORK_ITEMS CASCADE;
CREATE TABLE IF NOT EXISTS TEST_WORK_ITEMS
(
    ID           SERIAL,
    TEST_ID      INT       NOT NULL,
    WORK_ITEM_ID INT       NOT NULL,
    MODIFIED_AT  TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (WORK_ITEM_ID) REFERENCES WORK_ITEMS (ID)
);

DROP TABLE IF EXISTS TEST_METRICS CASCADE;
CREATE TABLE IF NOT EXISTS TEST_METRICS
(
    ID          SERIAL,
    OPERATION   VARCHAR(127) NOT NULL,
    ELAPSED     BIGINT       NOT NULL,
    TEST_ID     INT          NOT NULL,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (TEST_ID) REFERENCES TESTS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS SETTINGS CASCADE;
CREATE TABLE IF NOT EXISTS SETTINGS
(
    ID           SERIAL,
    NAME         VARCHAR(255) NOT NULL,
    VALUE        TEXT         NULL,
    IS_ENCRYPTED BOOLEAN      NULL     DEFAULT FALSE,
    TOOL         VARCHAR(255) NULL,
    FILE         BYTEA        NULL,
    MODIFIED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

CREATE SCHEMA IF NOT EXISTS management;
DROP TABLE IF EXISTS management.WIDGET_TEMPLATES CASCADE;
create table management.WIDGET_TEMPLATES
(
    ID                      SERIAL,
    NAME                    VARCHAR(255) NOT NULL,
    DESCRIPTION             VARCHAR(255) NOT NULL,
    TYPE                    VARCHAR(20) NOT NULL,
    SQL                     TEXT,
    CHART_CONFIG            TEXT,
    PARAMS_CONFIG           TEXT,
    LEGEND_CONFIG           TEXT,
    PARAMS_CONFIG_SAMPLE    TEXT,
    HIDDEN                  BOOLEAN DEFAULT false not null,
    MODIFIED_AT             TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT              TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

DROP TABLE IF EXISTS WIDGETS CASCADE;
CREATE TABLE IF NOT EXISTS WIDGETS
(
    ID                 SERIAL,
    TITLE              VARCHAR(255) NOT NULL,
    DESCRIPTION        VARCHAR(255) NULL,
    PARAMS_CONFIG      TEXT         NULL,
    LEGEND_CONFIG      TEXT         NULL,
    WIDGET_TEMPLATE_ID INT          NULL,
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    TYPE               VARCHAR(20)  NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (WIDGET_TEMPLATE_ID) REFERENCES management.WIDGET_TEMPLATES (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS DASHBOARDS CASCADE;
CREATE TABLE IF NOT EXISTS DASHBOARDS
(
    ID          SERIAL,
    TITLE       VARCHAR(255) NOT NULL,
    HIDDEN      BOOLEAN      NOT NULL DEFAULT FALSE,
    POSITION    INT          NOT NULL DEFAULT 0,
    EDITABLE    BOOLEAN      NOT NULL DEFAULT TRUE,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

DROP TABLE IF EXISTS DASHBOARDS_WIDGETS CASCADE;
CREATE TABLE IF NOT EXISTS DASHBOARDS_WIDGETS
(
    ID           SERIAL,
    DASHBOARD_ID INT          NOT NULL,
    WIDGET_ID    INT          NOT NULL,
    LOCATION     VARCHAR(255) NOT NULL DEFAULT '',
    MODIFIED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (DASHBOARD_ID) REFERENCES DASHBOARDS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (WIDGET_ID) REFERENCES WIDGETS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS SCM CASCADE;
CREATE TABLE IF NOT EXISTS SCM
(
    ID             SERIAL,
    NAME           VARCHAR(50)  NOT NULL,
    LOGIN          VARCHAR(255) NULL,
    ACCESS_TOKEN   VARCHAR(255) NOT NULL,
    ORGANIZATION   VARCHAR(255) NULL,
    REPO           VARCHAR(255) NULL,
    REPOSITORY_URL VARCHAR(255) NULL,
    USER_ID        INT          NULL,
    AVATAR_URL     VARCHAR(255) NULL,
    API_VERSION    VARCHAR(255) NULL,
    MODIFIED_AT    TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT     TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);

DROP TABLE IF EXISTS LAUNCHERS CASCADE;
CREATE TABLE IF NOT EXISTS LAUNCHERS
(
    ID          SERIAL,
    NAME        VARCHAR(255) NOT NULL,
    MODEL       TEXT         NOT NULL,
    SCM_ID      INT          NOT NULL,
    JOB_ID      INT          NULL,
    TYPE        VARCHAR(50),
    AUTO_SCAN   BOOLEAN      NOT NULL DEFAULT FALSE,
    MODIFIED_AT TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    FOREIGN KEY (SCM_ID) REFERENCES SCM (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (JOB_ID) REFERENCES JOBS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS LAUNCHER_PRESETS CASCADE;
CREATE TABLE IF NOT EXISTS LAUNCHER_PRESETS
(
    ID          SERIAL,
    NAME        VARCHAR(50) NOT NULL,
    REFERENCE   VARCHAR(20) NOT NULL,
    PARAMS      TEXT        NULL,
    LAUNCHER_ID INT         NOT NULL,
    PROVIDER_ID INT         NOT NULL,
    MODIFIED_AT TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT  TIMESTAMP   NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    CONSTRAINT FK_LAUNCHER_PRESET_LAUNCHERS1
        FOREIGN KEY (LAUNCHER_ID)
            REFERENCES LAUNCHERS (ID)
            ON DELETE CASCADE
            ON UPDATE NO ACTION,
    CONSTRAINT FK_LAUNCHER_PRESET_INTEGRATIONS1
        FOREIGN KEY (PROVIDER_ID)
            REFERENCES INTEGRATIONS (ID)
            ON DELETE CASCADE
            ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS LAUNCHER_CALLBACKS CASCADE;
CREATE TABLE IF NOT EXISTS LAUNCHER_CALLBACKS
(
    ID                 SERIAL,
    CI_RUN_ID          VARCHAR(50)  NOT NULL,
    URL                VARCHAR(255) NOT NULL,
    REFERENCE          VARCHAR(20)  NOT NULL,
    LAUNCHER_PRESET_ID INT          NOT NULL,
    MODIFIED_AT        TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT         TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID),
    CONSTRAINT FK_LAUNCHER_CALLBACK_LAUNCHER_PRESETS1
        FOREIGN KEY (LAUNCHER_PRESET_ID)
            REFERENCES LAUNCHER_PRESETS (ID)
            ON DELETE CASCADE
            ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS USER_LAUNCHER_PREFERENCES CASCADE;
CREATE TABLE IF NOT EXISTS USER_LAUNCHER_PREFERENCES
(
    ID          SERIAL,
    USER_ID     INT     NOT NULL,
    LAUNCHER_ID INT     NOT NULL,
    FAVORITE    BOOLEAN NULL DEFAULT FALSE,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION,
    FOREIGN KEY (LAUNCHER_ID) REFERENCES LAUNCHERS (ID)
        ON DELETE CASCADE
        ON UPDATE NO ACTION
);

DROP TABLE IF EXISTS TEST_SESSIONS CASCADE;
CREATE TABLE TEST_SESSIONS
(
    ID           SERIAL,
    SESSION_ID   VARCHAR(255) NOT NULL,
    VERSION      VARCHAR(255) NOT NULL,
    STARTED_AT   TIMESTAMP    NOT NULL,
    ENDED_AT     TIMESTAMP    NULL,
    DURATION     INT          NULL,
    OS_NAME      VARCHAR(255) NOT NULL,
    BROWSER_NAME VARCHAR(255) NOT NULL,
    TEST_NAME    VARCHAR(255) NULL,
    BUILD_NUMBER VARCHAR(255) NULL,
    STATUS       VARCHAR(20)  NOT NULL,
    MODIFIED_AT  TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    CREATED_AT   TIMESTAMP    NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (ID)
);